#!/usr/bin/perl -w

# plook, part of the pabber family of Exchange-No-More utilities.

# pabber is an attempt to add the functionally of the Personal Address
# Book found in Microsoft Exchange/Outlook. pabber will allow a user
# to search the Global Address Book and add users to pine's .addressbook
# file. It does this using LDAP routines that hook it into an Exchange
# server. Obviously, the user will need to have read access to such
# a beast.

# This little ditty, plook, was written early in pabber's development
# to test searching and such. As it turned out, it's a handy little
# command line tool for looking up someone's phone number or address
# Thus, I've kept it as part of the pabber release.

# plook is Copyright (c) 2000  Marc Richter - marc@vitinc.com
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

use Net::LDAP qw(:all);

$server = "usrymx04.merck.com";  # replace with your server, okay?
$size_limit = 75; # if you get no results from known good names, try
                  # making this a smaller value

$ldap = Net::LDAP->new($server) or die "Unable to access LDAP server!";

# subroutine for search...modify it to meet my needs

    sub LDAPsearch
        {
          my ($ldap,$searchString,$attrs,$base) = @_ ;
          # if they don't pass a base... set it for them
          if (!$base ) { $base = "c=us"; }
          # if they don't pass an array of attributes...
          # set up something for them
          if (!$attrs ) { $attrs = ['cn','mail' ]; }
          my $result = $ldap->search (
                base    => "$base",
                scope   => "sub",
                filter  => "$searchString",
                attrs   =>  $attrs,
		sizelimit => $size_limit
                );
        }

my @Attrs = ();             # request all available attributes
                                # to be returned.

print "Searching on " . $ARGV[0] . "\n";

my $result = LDAPsearch($ldap,"sn=" . $ARGV[0],\@Attrs);

my @entries = $result->entries;

my $entr ;

        foreach $entr ( @entries )
           {
	       print $entr->get_value('cn'), "\n";
	       print $entr->get_value('telephoneNumber'), "\n";
	       print $entr->get_value('mail'), "\n";
               print "#-------------------------------\n";
           }

print "\n", $result->count, " total records returned.\n";
