#!/usr/bin/perl -w


# pabber is an attempt to add the functionally of the Personal Address
# Book found in Microsoft Exchange/Outlook. pabber will allow a user
# to search the Global Address Book and add users to pine's .addressbook
# file. It does this using LDAP routines that hook it into an Exchange
# server. Obviously, the user will need to have read access to such
# a beast.

# this piece uses the plook code to make a scrolling list of the results

# plook is Copyright (c) 2000  Marc Richter - marc@vitinc.com
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.

use Tk;

use Net::LDAP qw(:all);

$server = "usrymx04.merck.com";  # replace with your server, okay?
$base = "o=Merck";               # replace with your base
$size_limit = 75; # if you get no results from known good names, try
                  # making this a smaller value

$ldap = Net::LDAP->new($server) or die "Unable to access LDAP server!";


sub freshen; # need to foward declare
sub update_list;

# subroutine for search...modify it to meet my needs

    sub LDAPsearch
        {
          my ($ldap,$searchString,$attrs) = @_ ;
          # if they don't pass a base... set it for them
          # if (!$base ) { $base = "o=Merck"; }
          # if they don't pass an array of attributes...
          # set up something for them
          if (!$attrs ) { $attrs = ['cn','mail' ]; }
          my $result = $ldap->search (
                base    => "$base",
                scope   => "sub",
                filter  => "$searchString",
                attrs   =>  $attrs,
		sizelimit => $size_limit
                );
        }

my @Attrs = ();             # request all available attributes
                                # to be returned.

#print "Searching on " . $ARGV[0] . "\n";

#my $result = LDAPsearch($ldap,"sn=" . $ARGV[0],\@Attrs);

#my @entries = $result->entries;

#my $entr ;

#        foreach $entr ( @entries )
#           {
#	       print $entr->get_value('cn'), "\n";
#	       print $entr->get_value('telephoneNumber'), "\n";
#	       print $entr->get_value('mail'), "\n";
#               print "#-------------------------------\n";
#           }

#print "\n", $result->count, " total records returned.\n";

# gimme some GUI!

$mw = MainWindow->new;

$mw->title("pabber - GUI test");

# define search entry widget and appropriate search button

my $search_string = $mw->Entry()->pack(-side =>"top",-anchor=>'w');

$mw->Button(-text => "Find",
	    -command => sub {update_list($search_string->get());})->
	    pack(-anchor=>'w');

# define listbox widget that is used to list search results
# also, bind clicks on entries to "freshen" sub, which
# will update the details for the selected entry
# so that we may review the item before we add to .addressbook

my $lb = $mw->Scrolled("Listbox", -scrollbars => "osoe")->pack(-anchor=>'w');

$lb->bind("<Button-1>", sub {freshen;});

#define display fields for selected user in search list

$mw->Label(-text=>"E-mail address")->pack(-anchor=>'w');
my $email_address = $mw->Entry(-width=>'40')->pack(-anchor=>'w');
$mw->Label(-text=>"Phone")->pack(-anchor=>'w');
my $phone = $mw->Entry(-width=>'20')->pack(-anchor=>'w');

$mw->Button(-text =>"Exit",
	    -command => sub{exit;})->pack(-anchor=>'w');

MainLoop;

sub freshen
{
    @selected = $lb->curselection;
    foreach (@selected) {
	my $mail_displayed= $entries[$_]->get_value('mail');
	my $phone_displayed= $entries[$_]->get_value('telephoneNumber');
	$email_address->delete(0,'end');
        $email_address->insert(0,$mail_displayed);
	$phone->delete(0,'end');
	$phone->insert(0,$phone_displayed);
    }
}

sub update_list
{
    my $gettem = @_[0];
 #   print $gettem;
    $lb->delete(0, 'end');	
    $email_address->delete(0,'end');
    $phone->delete(0,'end');
    $result = LDAPsearch($ldap,"sn=" . $gettem,\@Attrs);
    @entries = $result->entries;  
    foreach $entr (@entries)
    {
	$lb->insert("end", $entr->get_value('cn'));
    }
}
